ENT.Base = 'base_brush'
ENT.Type = 'brush'

ENT.OnTrigger = {}
ENT.NextMap = ''
ENT.DisableTouch = false
ENT.PreviousChapter = false
ENT.Enabled = true

local FLAG_DISABLE_TOUCH = 0x0002
local FLAG_PREV_CHAPTER = 0x0004

function ENT:ChangeLevel( force )
	if not self.Enabled then return end
	
	for n, o in pairs( self.OnTrigger ) do
		for _, e in pairs( ents.FindByName( o[1] ) ) do
			e:Fire( o[2], o[3], o[4] )
		end
		
		if o[5] == -1 then
			table.remove( self.OnTrigger, n )
		end
	end
	
	if not self.DisableTouch or force then
		RunConsoleCommand( "changelevel", self.NextMap )
	end
end

function ENT:StartTouch( ent )
	if ent:IsPlayer() then self:ChangeLevel() end
end

function ENT:KeyValue( k, v )
	if k == 'OnTrigger' then table.insert( self.OnTrigger, v:Split( ',' ) ) end
	if k == 'StartDisabled' then self.Enabled = tonumber( v ) == 0 end
	if k == 'map' then self.NextMap = v end
	
	if k == 'spawnflags' then
		self.DisableTouch = bit.band( tonumber( v ), FLAG_DISABLE_TOUCH ) ~= 0
		
		if bit.band( tonumber( v ), FLAG_PREV_CHAPTER ) ~= 0 then
			self.ChangeLevel = function() end
			self:SetSolid( SOLID_VPHYSICS )
		end
	end
end

function ENT:AcceptInput( input )
	if input == 'ChangeLevel' then self:ChangeLevel( true ) end
	if input == 'Enable' then self.Enabled = true end
	if input == 'Disable' then self.Enabled = false end
end