AddCSLuaFile( "cl_init.lua" )
AddCSLuaFile( "shared.lua" )
include( "shared.lua" )

CreateConVar( "hr_flashlight", "1" )
CreateConVar( "hr_weapon_357", "0" )
CreateConVar( "hr_weapon_ar2", "0" )
CreateConVar( "hr_weapon_crossbow", "0" )
CreateConVar( "hr_weapon_crowbar", "1" )
CreateConVar( "hr_weapon_frag", "0" )
CreateConVar( "hr_weapon_physcannon", "0" )
CreateConVar( "hr_weapon_pistol", "0" )
CreateConVar( "hr_weapon_rpg", "0" )
CreateConVar( "hr_weapon_shotgun", "0" )
CreateConVar( "hr_weapon_smg1", "0" )
CreateConVar( "hr_weapon_stunstick", "0" )
CreateConVar( "hr_collidewithplayers", "0" )
CreateConVar( "hr_noclip", "0" )
CreateConVar( "hr_player_walkspeed", "120" )
CreateConVar( "hr_player_runspeed", "240" )
CreateConVar( "hr_player_jumpspeed", "200" )

include( "player_equipment.lua" )
include ( "player_model.lua" )

function GM:PlayerNoClip( ply )
	if(GetConVar("hr_noclip"):GetInt() == 0) then
		return false
	else
		return true
	end
end

function GM:InitPostEntity()

	local props = ents.FindByName("ghorror_blockage")
	for k in pairs(props) do
		props[k]:Remove()
	end
	
	local props2 = ents.FindByName("ghorror_blockage2")
	for k2 in pairs(props2) do
		props2[k2]:Remove()
	end
	
	local setModel01 = ents.FindByName("ghorror_npc_classic")
	for x in pairs(setModel01) do
		setModel01[x]:SetModel("models/zombie/classic.mdl")
		setModel01[x]:SetHealth(setModel01[x]:GetSkin( ))
	end
	
	local setModel02 = ents.FindByName("ghorror_npc_fast")
	for z in pairs(setModel02) do
		setModel02[z]:SetModel("models/zombie/fast.mdl")
		setModel02[z]:SetHealth(setModel02[z]:GetSkin( ))
	end
	
	local setModel03 = ents.FindByName("ghorror_npc_poison")
	for y in pairs(setModel03) do
		setModel03[y]:SetModel("models/zombie/poison.mdl")
		setModel03[y]:SetHealth(setModel03[y]:GetSkin( ))
	end
	
	local customHP = ents.FindByName("ghorror_npc_customhealth")
	for m in pairs(customHP) do
		customHP[m]:SetHealth(customHP[m]:GetSkin( ))
	end
end

function GM:PlayerSwitchFlashlight(ply)
    if(GetConVar("hr_flashlight"):GetInt() == 0) then
		return false
	else
		return true
	end
end

function GM:ShouldCollide( ent1, ent2 )
     
	if ent1:IsPlayer() and ent2:IsPlayer() then
		if(GetConVar("hr_collidewithplayers"):GetInt() == 0) then
			return false
	    else
	       return true
        end
	else
		return true
	end
end

function WEPS.DropNotifiedWeapon(ply, wep) 
    ply:DropWeapon(wep)
    wep:PhysWake()
end

local function DropActiveWeapon(ply)
   if not IsValid(ply) then return end

   local wep = ply:GetActiveWeapon()

   if not IsValid(wep) then return end

   if wep.AllowDrop == false then
      return
   end

   local tr = util.QuickTrace(ply:GetShootPos(), ply:GetAimVector() * 32, ply)

   if tr.HitWorld then
      ply:PrintMessage(HUD_PRINTTALK, "You can't drop that there.")
      return
   end

   WEPS.DropNotifiedWeapon(ply, wep)
end

concommand.Add("ex_dropweapon", DropActiveWeapon)

function playerCommands( ply, text, public )
    if (string.sub(text, 1, 8) == "!version") then
        ply:ChatPrint("This server is running Garry's Horror 1.06")
    end
end
hook.Add( "PlayerSay", "playerCom", playerCommands );